function [ result ] = z_deblur(img, filterSize, processType, areImagesRGB, numIterations, processBegin, processEnd)
%Z_DEBLUR Summary of this function goes here
%   Detailed explanation goes here
if(areImagesRGB)
    disp('Deblurring Channel 1');
    pBegin = processBegin;
    pEnd = (1/3) * processEnd + (2/3) * processBegin;
    result = z_deblurSingleChannel(img(:,:,1), filterSize, processType, numIterations, 0, 33, pBegin, pEnd);
    disp('Deblurring Channel 2');
    pBegin = (1/3) * processEnd + (2/3) * processBegin;
    pEnd = (2/3) * processEnd + (1/3) * processBegin;
    result(:,:,2) = z_deblurSingleChannel(img(:,:,2), filterSize, processType, numIterations, 33, 67, pBegin, pEnd);
    disp('Deblurring Channel 3');
    pBegin = (2/3) * processEnd + (1/3) * processBegin;;
    pEnd = processEnd;
    result(:,:,3) = z_deblurSingleChannel(img(:,:,3), filterSize, processType, numIterations, 67, 100, pBegin, pEnd);
else
    disp('Deblurring Grayscale Image');
    pBegin = processBegin;
    pEnd = processEnd;
    result = z_deblurSingleChannel(img, filterSize, processType, numIterations, 0, 100, pBegin, pEnd);
end

