function [proj, v] = proj(y0, x1, x2, ny)

ox = x1;

ox2 = x2;
x2 = x2(1:end-1);

rs = ny;

im = reshape(x2, rs, []);
[ny nx] = size(im);


%% Gradient - [1 -1] filter - Matrix form
im = padarray(im, [1 1], 'symmetric');

df1 = sign(conv2(im,.5*[1 -1],'valid'));
df2 = sign(conv2(im,.5*[1; -1],'valid'));

zVec1 = zeros(size(df1,1),1);
zVec2 = zeros(1,size(df2,2));

df1 = [zVec1  df1  zVec1];
df2 = [zVec2;  df2;  zVec2];

grad_tv = conv2(df1,[-1 +1],'valid') + conv2(df2,[-1; 1],'valid');
grad_tv = grad_tv(2:ny+1,2:nx+1);

%% Gradient - [-1 2 -1] filter - Matrix form
% fil = [-1 2 -1];%[0.5 0.5 -0.5 -0.5 0 0 0];
% % L = length(fil);
% % s = round(length(fil)/2);
% % zVec1 = zeros(size(im,1),s);
% % im1 = [zVec1  im  zVec1];
% % zVec2 = zeros(s,size(im1,2));
% % im1 = [zVec2;  im1;  zVec2];
% L = length(fil);
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% df1 = sign(conv2(im,fil,'valid'));
% df2 = sign(conv2(im,fil','valid'));
% 
% % df1 = sign(conv2(im1,[-1 2 -1],'valid'));
% % df2 = sign(conv2(im1,[-1; 2; -1],'valid'));
% 
% zVec1 = zeros(size(df1,1),s);
% df1 = [zVec1 df1 zVec1];
% zVec2 = zeros(s,size(df2,2));
% df2 = [zVec2; df2; zVec2];
% 
% grad_tv = conv2(df1(L-s:end-L+s+1, :),fliplr(fil),'valid') + conv2(df2(:, L-s:end-L+s+1),fliplr(fil)','valid');
% %conv2(df1,-[1 -2 1],'valid') + conv2(df2,-[1; -2; 1],'valid');
% grad_tv = grad_tv(3:ny+2,3:nx+2);

%% [0.5 0.5 -0.5 -0.5] filter;
% fil = [0.5 0.5 -0.5 -0.5];
% L = length(fil);
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% df1 = sign(conv2(im,fil,'valid'));
% df2 = sign(conv2(im,fil','valid'));
% 
% zVec1 = zeros(size(df1,1),s);
% df1 = [zVec1 df1 zVec1];
% zVec2 = zeros(s,size(df2,2));
% df2 = [zVec2; df2; zVec2];
% 
% grad_tv = conv2(df1(L-s:end-L+s+1, :),-fil,'valid') + conv2(df2(:, L-s:end-L+s+1),-fil','valid');
% grad_tv = grad_tv(2:ny+1,2:nx+1);

%% [.125 .25 1 -.25 -.125]/0.375 filter;
% fil = [.125 .25 1 -.25 -.125]/0.375;
% L = length(fil);
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% df1 = sign(conv2(im,fil,'valid'));
% df2 = sign(conv2(im,fil','valid'));
% 
% zVec1 = zeros(size(df1,1),1);
% zVec2 = zeros(1,size(df2,2));
% 
% df1 = [zVec1 zVec1 zVec1 df1  zVec1 zVec1 zVec1];
% df2 = [zVec2; zVec2; zVec2; df2;  zVec2; zVec2; zVec2];
% 
% grad_tv = conv2(df1(L-s:end-L+s+1, :),-fil,'valid') + conv2(df2(:, L-s:end-L+s+1),-fil','valid');
% grad_tv = grad_tv(2:ny+1,2:nx+1);

%% [.125 .25 0.5 -0.5 -.25 -.125]/0.825 filter;
% fil = [.125 .25 0.5 -0.5 -.25 -.125]/0.825;
% L = length(fil);
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% df1 = sign(conv2(im,fil,'valid'));
% df2 = sign(conv2(im,fil','valid'));
% 
% zVec1 = zeros(size(df1,1),1);
% zVec2 = zeros(1,size(df2,2));
% 
% df1 = [zVec1 zVec1 zVec1 df1  zVec1 zVec1 zVec1];
% df2 = [zVec2; zVec2; zVec2; df2;  zVec2; zVec2; zVec2];
% 
% grad_tv = conv2(df1(L-s:end-L+s+1, :),-fil,'valid') + conv2(df2(:, L-s:end-L+s+1),-fil','valid');%conv2(df1(3:end-2, :),-fil,'valid') + conv2(df2(:, 3:end-2),-fil','valid');
% grad_tv = grad_tv(2:ny+1,2:nx+1);

%% [-0.0808 0 0.4155 -0.5376 0.1653 0.0624 0 -0.0248] filter VALID
% % [~,fil,~,~] = wfilters('db3');
% fil = [-1 2 -1];%[0.5 0.5 -0.5 -0.5 0 0 0];
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% df1 = sign(conv2(im,fil,'valid'));
% df2 = sign(conv2(im,fil','valid'));
% 
% zVec1 = zeros(size(df1,1),s);
% zVec2 = zeros(s,size(df2,2));
% 
% df1 = [zVec1 df1  zVec1];
% df2 = [zVec2; df2;  zVec2];
% 
% grad_tv1 =  conv2(df1,-fil,'valid');
% grad_tv2 =  conv2(df2,-fil','valid');
% grad_tv = grad_tv1(s+1:end-s,s+1:end-s) + grad_tv2(s+1:end-s,s+1:end-s);

%% [-0.0808 0 0.4155 -0.5376 0.1653 0.0624 0 -0.0248] filter SAME
% % [~,fil,~,~] = wfilters('db3');
% fil = [0.5 -0.5];%[0.5 0.5 -0.5 -0.5 0 0 0];
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% df1 = sign(conv2(im,fil,'same'));
% df2 = sign(conv2(im,fil','same'));
% 
% zVec1 = zeros(size(df1,1),s);
% zVec2 = zeros(s,size(df2,2));
% 
% df1 = [zVec1 df1  zVec1];
% df2 = [zVec2; df2;  zVec2];
% 
% grad_tv =  conv2(df1(:, s+1:end-s),-fil,'same') + conv2(df2(s+1:end-s, :),-fil','same');
% grad_tv = grad_tv(s+1:end-s,s+1:end-s);

%% Gradient - [0 -0.25 0; -0.25 1 -0.25; 0 -0.25 0] filter - Matrix form
% zVec1 = zeros(size(im,1),1);
% im1 = [zVec1  im  zVec1];
% im1 = [zVec1  im1  zVec1];
% 
% zVec2 = zeros(1,size(im1,2));
% im = [zVec2;  im1;  zVec2];
% im = [zVec2;  im;  zVec2];
% 
% df = conv2(im,[0 -0.25 0; -0.25 1 -0.25; 0 -0.25 0],'valid');
% 
% df = sign(df);
% 
% grad_tv = conv2(df,[0 -0.25 0; -0.25 1 -0.25; 0 -0.25 0],'valid');

%% Gradient - [0 -0.25 0; -0.25 1 -0.25; 0 -0.25 0] filter - For loop form
% zVec1 = zeros(size(im,1),1);
% im1 = [zVec1  im  zVec1];
% im1 = [zVec1  im1  zVec1];
% 
% zVec2 = zeros(1,size(im1,2));
% im2 = [zVec2;  im1;  zVec2];
% im = [zVec2;  im2;  zVec2];
% 
% for i = 3:514
%     for j = 3:514
%         df(i,j) = sign(im(i,j) - 0.25*(im(i,j+1) + im(i,j-1) + im(i-1,j) + im(i+1,j))) - ...
%         0.25*(sign(im(i-1,j) - 0.25*(im(i,j) + im(i-1,j-1) + im(i-1,j+1) + im(i-2,j))) + ...
%         sign(im(i,j+1) - 0.25*(im(i,j) + im(i,j+2) + im(i-1,j+1) + im(i+1,j+1))) + ...
%         sign(im(i,j-1) - 0.25*(im(i,j) + im(i-1,j-1) + im(i,j-2) + im(i+1,j-1))) + ...
%         sign(im(i+1,j) - 0.25*(im(i,j) + im(i+1,j+1) + im(i+2,j) + im(i+1,j-1))));
%     end
% end
% 
% grad_tv = df(2:ny+1,2:nx+1);

%% Gradient - [-1 2 -1] filter - Matrix form
% zVec1 = zeros(size(im,1),1);
% im1 = [zVec1  im  zVec1];
% im1 = [zVec1  im1  zVec1];
% 
% zVec2 = zeros(1,size(im1,2));
% im = [zVec2;  im1;  zVec2];
% im = [zVec2;  im;  zVec2];
% df1 = sign(conv2(im,[-1 2 -1],'valid'));
% df2 = sign(conv2(im,[-1; 2; -1],'valid'));
% 
% zVec1 = zeros(size(df1,1),1);
% zVec2 = zeros(1,size(df2,2));
% 
% df1 = [zVec1  df1  zVec1];
% df1 = [zVec1  df1  zVec1];
% df2 = [zVec2;  df2;  zVec2];
% df2 = [zVec2;  df2;  zVec2];
% 
% grad_tv = conv2(df1,-[1 -2 1],'valid') + conv2(df2,-[1; -2; 1],'valid');
% grad_tv = grad_tv(3:ny+2,3:nx+2);

%% Gradient - [-1 -1 2] filter - For loop form
% zVec1 = zeros(size(im,1),1);
% im1 = [zVec1  im  zVec1];
% im1 = [zVec1  im1  zVec1];
% 
% zVec2 = zeros(1,size(im1,2));
% im = [zVec2;  im1;  zVec2];
% im = [zVec2;  im;  zVec2];
% 
% for i = 3:514
%     for j = 3:514
%         df(i,j) = -sign(-im(i,j) + 2*im(i+1,j) - im(i-1,j)) - ...
%             sign(-im(i+1,j) - im(i,j) + 2*im(i+2,j)) + ...
%             2*sign(-im(i-1,j) + 2*im(i,j) - im(i-2,j)) - ...
%             sign(-im(i,j) - im(i,j+1) + 2*im(i,j-1)) - ...
%             sign(-im(i,j-1) - im(i,j) + 2*im(i,j-2)) + ...
%             2*sign(-im(i,j+1) + 2*im(i,j) - im(i,j+2));
%     end
% end
% 
% grad_tv = df(3:ny+2,3:nx+2);

%% Gradient - [-1 -1 2] filter - Matrix form
% zVec1 = zeros(size(im,1),1);
% im1 = [zVec1  im  zVec1];
% im1 = [zVec1  im1  zVec1];
% 
% zVec2 = zeros(1,size(im1,2));
% im = [zVec2;  im1;  zVec2];
% im = [zVec2;  im;  zVec2];
% 
% df1 = sign(conv2(im,[-1 -1 2],'valid'));
% df2 = sign(conv2(im,[-1; -1; 2],'valid'));
% 
% zVec1 = zeros(size(df1,1),1);
% zVec2 = zeros(1,size(df2,2));
% 
% df1 = [zVec1  df1 zVec1];
% df1 = [zVec1  df1 zVec1];
% df2 = [zVec2;  df2; zVec2];
% df2 = [zVec2;  df2; zVec2];
% 
% grad_tv = conv2(df1,[2 -1 -1],'valid') + conv2(df2,[2; -1; -1],'valid');
% grad_tv = grad_tv(3:ny+2,3:nx+2);

%% Projection Formulla
normal = grad_tv(:);

v = [normal; -1];
v = v./norm(v);

proj = ox - (v*(v'*(ox-ox2)));

end