function [ tv, df ] = tv( im,rs )

im = reshape(im, rs, []);
[ny nx] = size(im);

%% [1 -1] filter - Matrix form
im = padarray(im, [1 1], 'symmetric');
df1 = conv2(im,.5*[1 -1],'valid');
df2 = conv2(im,.5*[1; -1],'valid');
tv = sum(abs(df1(:))) + sum(abs(df2(:)));

%% [-1 2 -1] filter - Matrix form
% fil = [-1 2 -1];
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% 
% df1 = conv2(im,[-1 2 -1],'valid');
% df2 = conv2(im,[-1; 2; -1],'valid');
% tv = sum(abs(df1(:))) + sum(abs(df2(:)));

%% [0.5 0.5 -0.5 -0.5] filter - Matrix form
% fil = [0.5 0.5 -0.5 -0.5];
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% 
% df1 = conv2(im,fil,'valid');
% df2 = conv2(im,fil','valid');
% tv = sum(abs(df1(:))) + sum(abs(df2(:)));

%% [.125 .25 1 -.25 -.125]/0.375 filter - Matrix form
% fil = [.125 .25 1 -.25 -.125]/0.375;
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% df1 = conv2(im,fil,'valid');
% df2 = conv2(im,fil','valid');
% tv = sum(abs(df1(:))) + sum(abs(df2(:)));

%% [.125 .25 0.5 -0.5 -.25 -.125]/0.825 filter - Matrix form
% fil = [.125 .25 0.5 -0.5 -.25 -.125]/0.825;
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% df1 = conv2(im,fil,'valid');
% df2 = conv2(im,fil','valid');
% tv = sum(abs(df1(:))) + sum(abs(df2(:)));

%% [-0.0808 0 0.4155 -0.5376 0.1653 0.0624 0 -0.0248] filter
% % [~,fil,~,~] = wfilters('db3');
% fil = [-1 2 -1];%[0.5 0.5 -0.5 -0.5 0 0 0];
% s = round(length(fil)/2);
% im = padarray(im, [s s], 'symmetric');
% df1 = conv2(im,fil,'valid');
% df2 = conv2(im,fil','valid');
% tv = sum(abs(df1(:))) + sum(abs(df2(:)));

%% [.125 .25 1 -1 .25 .125] filter - Matrix form - Vertical - [1; -1]Horiz
% zVec2 = zeros(size(im,1),1);
% im = [zVec2 zVec2 zVec2 im zVec2 zVec2 zVec2];
% 
% df = conv2(im,[.125 .25 1 -1 -.25 -.125],'valid');
% tv = sum(abs(df(:)));
% 
% zVec2 = zeros(1,size(df,2));
% im = [zVec2;  df;  zVec2];
% 
% df2 = conv2(im,[1; -1],'valid');
% tv = tv + sum(abs(df2(:)));

%% [1 -1] filter - For loop form
% im = [im(2,:); im; im(ny-1,:)];
% im = [im(:,2) im im(:,nx-1)];
% 
% im = [im(2,:); im; im(ny-1,:)];
% im = [im(:,2) im im(:,nx-1)];
% 
% for i = 3:514
%     for j = 3:514
%         tv1(i,j) = abs(im(i,j) - im(i,j-1)) + abs(im(i,j) - im(i-1,j));
%     end
% end
% 
% tv = sum(tv1(:));

%% [0 -0.25 0; -0.25 1 -0.25; 0 -0.25 0] filter - Matrix form
% zVec1 = zeros(size(im,1),1);
% im1 = [zVec1  im  zVec1];
% 
% zVec2 = zeros(1,size(im1,2));
% im = [zVec2;  im1;  zVec2];
% 
% a = [0 -0.25 0; -0.25 1 -0.25; 0 -0.25 0];
% df = conv2(im, a, 'valid');
% tv = sum(abs(df(:)));

%% [-1 2 -1] filter - Matrix form
% zVec1 = zeros(size(im,1),1);
% im1 = [zVec1  im  zVec1];
% 
% zVec2 = zeros(1,size(im1,2));
% im = [zVec2;  im1;  zVec2];
% 
% df1 = conv2(im,[-1 2 -1],'valid');
% df2 = conv2(im,[-1; 2; -1],'valid');
% tv = sum(abs(df1(:))) + sum(abs(df2(:)));


end