function [ filter ] = z_createFilter( type,sigmaradius,size )
if(strcmp(type,'disk'))
    filter=zeros(size);
    midpoint=(size+1)/2;
    for ii=1:size
        for jj=1:size
            d=sqrt((ii-midpoint)^2+(jj-midpoint)^2);
            if d < sigmaradius
                filter(ii,jj)=1;
            end
        end
    end
    filter=filter/sum(filter(:));
end
if(strcmp(type,'gaussian'))
    filter=fspecial('gaussian', [size,size],sigmaradius);
end

filter = filter/sum(filter(:));
end

